"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Module = require("module");
function hijackWebpackResove(webpack, rootDir) {
    const webpackRegex = /^webpack\//;
    // eslint-disable-next-line no-underscore-dangle
    const originalResolver = Module._resolveFilename;
    // eslint-disable-next-line no-underscore-dangle
    Module._resolveFilename = function (request, parent, isMain, options) {
        var _a, _b;
        if (request.match(webpackRegex)) {
            const newOptions = { paths: [] };
            if (options === null || options === void 0 ? void 0 : options.paths) {
                newOptions.paths = ((_a = options.paths) === null || _a === void 0 ? void 0 : _a.includes(rootDir)) ? options.paths : (_b = options.paths) === null || _b === void 0 ? void 0 : _b.concat(rootDir);
            }
            else {
                newOptions.paths.push(rootDir);
            }
            return originalResolver.apply(this, [request, parent, isMain, newOptions]);
        }
        return originalResolver.apply(this, [request, parent, isMain, options]);
    };
    const originalLoader = Module._load;
    // eslint-disable-next-line no-underscore-dangle
    Module._load = function (request, parent) {
        let moduleRequest = request;
        // ignore case which pass parent
        if (parent) {
            if (request === 'webpack') {
                return webpack;
            }
            else if (request.match(webpackRegex)) {
                try {
                    moduleRequest = require.resolve(request, { paths: [rootDir] });
                }
                catch (e) {
                    // ignore error
                }
            }
        }
        return originalLoader.apply(this, [moduleRequest, parent]);
    };
}
exports.default = hijackWebpackResove;
